import * as beet from '@metaplex-foundation/beet';
import * as web3 from '@safecoin/web3.js';
import { CreateMasterEditionArgs } from '../types/CreateMasterEditionArgs';
export type DeprecatedCreateMasterEditionInstructionArgs = {
    createMasterEditionArgs: CreateMasterEditionArgs;
};
export declare const DeprecatedCreateMasterEditionStruct: beet.FixableBeetArgsStruct<DeprecatedCreateMasterEditionInstructionArgs & {
    instructionDiscriminator: number;
}>;
export type DeprecatedCreateMasterEditionInstructionAccounts = {
    edition: web3.PublicKey;
    mint: web3.PublicKey;
    printingMint: web3.PublicKey;
    oneTimePrintingAuthorizationMint: web3.PublicKey;
    updateAuthority: web3.PublicKey;
    printingMintAuthority: web3.PublicKey;
    mintAuthority: web3.PublicKey;
    metadata: web3.PublicKey;
    payer: web3.PublicKey;
    tokenProgram?: web3.PublicKey;
    systemProgram?: web3.PublicKey;
    rent?: web3.PublicKey;
    oneTimePrintingAuthorizationMintAuthority: web3.PublicKey;
};
export declare const deprecatedCreateMasterEditionInstructionDiscriminator = 2;
export declare function createDeprecatedCreateMasterEditionInstruction(accounts: DeprecatedCreateMasterEditionInstructionAccounts, args: DeprecatedCreateMasterEditionInstructionArgs, programId?: web3.PublicKey): web3.TransactionInstruction;
