import * as web3 from '@safecoin/web3.js';
import * as beet from '@metaplex-foundation/beet';
export type ProgrammableConfigRecord = {
    V1: {
        ruleSet: beet.COption<web3.PublicKey>;
    };
};
export type ProgrammableConfig = beet.DataEnumKeyAsKind<ProgrammableConfigRecord>;
export declare const isProgrammableConfigV1: (x: ProgrammableConfig) => x is {
    __kind: "V1";
} & Omit<{
    ruleSet: beet.COption<web3.PublicKey>;
}, "void"> & {
    __kind: 'V1';
};
export declare const programmableConfigBeet: beet.FixableBeet<{
    __kind: "V1";
} & Omit<{
    ruleSet: beet.COption<web3.PublicKey>;
}, "void">, {
    __kind: "V1";
} & Omit<{
    ruleSet: beet.COption<web3.PublicKey>;
}, "void">>;
