import * as web3 from '@safecoin/web3.js';
import * as beet from '@metaplex-foundation/beet';
import { MigrationType } from './MigrationType';
export type MigrateArgsRecord = {
    V1: {
        migrationType: MigrationType;
        ruleSet: beet.COption<web3.PublicKey>;
    };
};
export type MigrateArgs = beet.DataEnumKeyAsKind<MigrateArgsRecord>;
export declare const isMigrateArgsV1: (x: MigrateArgs) => x is {
    __kind: "V1";
} & Omit<{
    migrationType: MigrationType;
    ruleSet: beet.COption<web3.PublicKey>;
}, "void"> & {
    __kind: 'V1';
};
export declare const migrateArgsBeet: beet.FixableBeet<{
    __kind: "V1";
} & Omit<{
    migrationType: MigrationType;
    ruleSet: beet.COption<web3.PublicKey>;
}, "void">, {
    __kind: "V1";
} & Omit<{
    migrationType: MigrationType;
    ruleSet: beet.COption<web3.PublicKey>;
}, "void">>;
